/* Copyright 2008-2011 Research Foundation State University of New York   */

/* This file is part of QUB Express.                                      */

/* QUB Express is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation, either version 3 of the License, or      */
/* (at your option) any later version.                                    */

/* QUB Express is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License,     */
/* named LICENSE.txt, in the QUB Express program directory.  If not, see  */
/* <http://www.gnu.org/licenses/>.                                        */

#ifndef QUB_IDLSTATS_H
#define QUB_IDLSTATS_H

#include "qubfast.h"

#ifdef __cplusplus
extern "C" {
#endif

  QUBFAST_API void*    qub_idlstats_create(double sampling);
  QUBFAST_API void     qub_idlstats_free(void *idls);
  QUBFAST_API void     qub_idlstats_reset(void *idls);
  QUBFAST_API void     qub_idlstats_add(void *idls, float *data, int ndwell, int offset,
					int *firsts, int *lasts, int *classes);
  QUBFAST_API int      qub_idlstats_add_up_means(void *idls); // returns Nclass
  QUBFAST_API double*  qub_idlstats_get_means(void *idls);
  QUBFAST_API double*  qub_idlstats_get_lifetimes(void *idls);
  QUBFAST_API double*  qub_idlstats_get_median_lifetimes(void *idls);
  QUBFAST_API double*  qub_idlstats_get_occupancies(void *idls);
  QUBFAST_API int*     qub_idlstats_get_nevents(void *idls);
  // now you re-add it all, then
  QUBFAST_API int      qub_idlstats_add_up_stds(void *idls); // returns Nclass
  QUBFAST_API double*  qub_idlstats_get_stds(void *idls);
  

#ifdef __cplusplus
}
#endif

#endif
